/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.1
 *
 * @date        2025-04-31
 *
 * @attention
 *
 *  Copyright (C) 2026 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (Geehy Semiconductor Software License Agreement).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the Geehy Semiconductor Software License Agreement for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "Port.h"
#include "CDD_Usart.h"
#include "Mcu.h"
#include "Icu.h"
#include "TestCommon.h"

/** @addtogroup Examples
  @{
  */

/**
* @brief  Icu Tmr low level signal measure.
* @note   In current example the core running in 40MHz, and the Tmr2 clock fre is 64MHz div 64.
  @{
  */
static void Icu_Tmr_LowLevSignalMeasure(void)
{
    char *l_p_name_test_case = "Icu_Tmr_LowLevSignalMeasure Example";
    uint32 l_circleCnt = 0xFF;

    print_test_start((uint8_t*)l_p_name_test_case);

    Icu_Init(&g_IcuConfig);

    NVIC_SetPriority(TMR2_IRQn, 0x0c);
    NVIC_EnableIRQ(TMR2_IRQn);

    Icu_StartSignalMeasurement(IcuChannel_1);

    printf("Give GPIOA3 Pwm signal:\r\n");

    while(l_circleCnt--)
    {
        /* Wait for the signal measure complete,the Delay only for 14KHz signal
         * if the high level is longer,please adjust the delay time */
        sys_delay(100000);
        printf("IcuChannel_1 current low level time is:0x%x\r\n", (int)Icu_GetTimeElapsed(IcuChannel_1)); 
    }

    Icu_StopSignalMeasurement(IcuChannel_1);
    print_test_end((uint8_t*)l_p_name_test_case);

    Icu_DeInit();
}

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
int main(void)
{
    Mcu_Init(&g_mcuConfig);
    Mcu_InitClock(McuClockSettingConfig_0);

    Port_Init(&g_portConfig);
    Usart_Init(g_usartConfg); //TX PIN:PA9

    Icu_Tmr_LowLevSignalMeasure();

    while(1)
    {
     
    }
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*
* @note
*/
int fputc(int ch, FILE* f)
{
    int reVal = 0;
    reVal = Usart_PutRedefinition(USART1_ID,&ch);
    
    return reVal;
}

/* If configuring the full library using versions after IAR 9.30,
   it is necessary to implement the _write function for printf redirection.*/
size_t __write(int handle,const unsigned char *buf,size_t bufSize)
{
    int32 tempCh = 0;
    for(int i=0; i<bufSize; i++)
    {
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return bufSize;
}

#elif defined (__GNUC__)

/* For Arm Cross GCC: Eclipse */
int _write(int fd,const unsigned char *buf,int len)
{
    int32 tempCh = 0;
    for(int i=0; i<len; i++)
    {
        int32 tempCh = (int32)buf[i];
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return len;
}

#endif
/**@} end of group Template_Functions */
/**@} end of group Template */
/**@} end of group Examples */
